package handler

import (
	"context"
	"database/sql"
	"errors"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) CommentDelete(ctx context.Context, req *pb.CommentDeleteReq, rsp *pb.CommentDeleteRsp) error {
	h.logger.Debug(ctx, "Start AddComment")

	err := req.Validate()
	if err != nil {
		h.logger.Error(ctx, "validate error", err)
		httpsrv.SetRspCode(ctx, http.StatusBadRequest)
		return httpsrv.SetError(NewValidationError(err))
	}

	if err = h.store.CommentDelete(ctx, req); err != nil {

		if errors.Is(err, sql.ErrNoRows) {
			httpsrv.SetRspCode(ctx, http.StatusNotFound)
			return httpsrv.SetError(NewNotFoundError(err))
		}
		h.logger.Error(ctx, "comment delete error", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	h.logger.Debug(ctx, "Success finish addComment")
	return nil
}
